from FreeCAD import Base
import FreeCAD, Part, math
import DraftVecUtils
import Sketcher
import PartDesign
from math import pi
import Draft
import FreeCAD as App
from . import psuport_data
class S05:
    def __init__(self, obj):
        self.Type = 'S05'
        obj.Proxy = self
        App.activeDocument().recompute(None,True,True)
    def execute(self, obj):
        label=obj.Name
        key=App.ActiveDocument.getObject(label).key
        H1=App.ActiveDocument.getObject(label).H1
        t=App.ActiveDocument.getObject(label).t
        d1=App.ActiveDocument.getObject(label).d1
        d=App.ActiveDocument.getObject(label).d
        w=d+30
        h=12*d
        c01=Part.makeBox(w,h,t)
        c01.Placement=App.Placement(App.Vector(0,0,0),App.Rotation(App.Vector(1,0,0),-90))
        c02=Part.makeBox(w,h,t)
        c02.Placement=App.Placement(App.Vector(0,0,H1-12*d),App.Rotation(App.Vector(1,0,0),-90))
        for i in range(2):
            if i==0:
                y=6*d
            elif i==1:
                y=2*d
            c03=Part.makeCylinder(d/2,t,Base.Vector(w/2,0,H1-h-y),Base.Vector(0,1,0),360)
            c02=c02.cut(c03)
        c01=c01.fuse(c02)
        c02=Part.makeCylinder(d1/2,H1-16*d,Base.Vector(w/2,-d1/2,-4*d),Base.Vector(0,0,1),360)
        c01=c01.fuse(c02)
        c1=c01
        obj.Shape=c1 